'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var util = _interopDefault(require('util'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function Layout(props) {
    return (React.createElement("k_layout", { style: __assign({}, props.style), className: props.className, config: props.config, plugins: props.plugins, debugHooks: props.debugHooks, hide: props.hide }));
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

class Hook {
	constructor(args) {
		if (!Array.isArray(args)) args = [];
		this._args = args;
		this.taps = [];
		this.interceptors = [];
		this.call = this._call;
		this.promise = this._promise;
		this.callAsync = this._callAsync;
		this._x = undefined;
	}

	compile(options) {
		throw new Error("Abstract: should be overriden");
	}

	_createCall(type) {
		return this.compile({
			taps: this.taps,
			interceptors: this.interceptors,
			args: this._args,
			type: type
		});
	}

	tap(options, fn) {
		if (typeof options === "string") options = { name: options };
		if (typeof options !== "object" || options === null)
			throw new Error(
				"Invalid arguments to tap(options: Object, fn: function)"
			);
		options = Object.assign({ type: "sync", fn: fn }, options);
		if (typeof options.name !== "string" || options.name === "")
			throw new Error("Missing name for tap");
		options = this._runRegisterInterceptors(options);
		this._insert(options);
	}

	tapAsync(options, fn) {
		if (typeof options === "string") options = { name: options };
		if (typeof options !== "object" || options === null)
			throw new Error(
				"Invalid arguments to tapAsync(options: Object, fn: function)"
			);
		options = Object.assign({ type: "async", fn: fn }, options);
		if (typeof options.name !== "string" || options.name === "")
			throw new Error("Missing name for tapAsync");
		options = this._runRegisterInterceptors(options);
		this._insert(options);
	}

	tapPromise(options, fn) {
		if (typeof options === "string") options = { name: options };
		if (typeof options !== "object" || options === null)
			throw new Error(
				"Invalid arguments to tapPromise(options: Object, fn: function)"
			);
		options = Object.assign({ type: "promise", fn: fn }, options);
		if (typeof options.name !== "string" || options.name === "")
			throw new Error("Missing name for tapPromise");
		options = this._runRegisterInterceptors(options);
		this._insert(options);
	}

	_runRegisterInterceptors(options) {
		for (const interceptor of this.interceptors) {
			if (interceptor.register) {
				const newOptions = interceptor.register(options);
				if (newOptions !== undefined) options = newOptions;
			}
		}
		return options;
	}

	withOptions(options) {
		const mergeOptions = opt =>
			Object.assign({}, options, typeof opt === "string" ? { name: opt } : opt);

		// Prevent creating endless prototype chains
		options = Object.assign({}, options, this._withOptions);
		const base = this._withOptionsBase || this;
		const newHook = Object.create(base);

		(newHook.tapAsync = (opt, fn) => base.tapAsync(mergeOptions(opt), fn)),
			(newHook.tap = (opt, fn) => base.tap(mergeOptions(opt), fn));
		newHook.tapPromise = (opt, fn) => base.tapPromise(mergeOptions(opt), fn);
		newHook._withOptions = options;
		newHook._withOptionsBase = base;
		return newHook;
	}

	isUsed() {
		return this.taps.length > 0 || this.interceptors.length > 0;
	}

	intercept(interceptor) {
		this._resetCompilation();
		this.interceptors.push(Object.assign({}, interceptor));
		if (interceptor.register) {
			for (let i = 0; i < this.taps.length; i++)
				this.taps[i] = interceptor.register(this.taps[i]);
		}
	}

	_resetCompilation() {
		this.call = this._call;
		this.callAsync = this._callAsync;
		this.promise = this._promise;
	}

	_insert(item) {
		this._resetCompilation();
		let before;
		if (typeof item.before === "string") before = new Set([item.before]);
		else if (Array.isArray(item.before)) {
			before = new Set(item.before);
		}
		let stage = 0;
		if (typeof item.stage === "number") stage = item.stage;
		let i = this.taps.length;
		while (i > 0) {
			i--;
			const x = this.taps[i];
			this.taps[i + 1] = x;
			const xStage = x.stage || 0;
			if (before) {
				if (before.has(x.name)) {
					before.delete(x.name);
					continue;
				}
				if (before.size > 0) {
					continue;
				}
			}
			if (xStage > stage) {
				continue;
			}
			i++;
			break;
		}
		this.taps[i] = item;
	}
}

function createCompileDelegate(name, type) {
	return function lazyCompileHook(...args) {
		this[name] = this._createCall(type);
		return this[name](...args);
	};
}

Object.defineProperties(Hook.prototype, {
	_call: {
		value: createCompileDelegate("call", "sync"),
		configurable: true,
		writable: true
	},
	_promise: {
		value: createCompileDelegate("promise", "promise"),
		configurable: true,
		writable: true
	},
	_callAsync: {
		value: createCompileDelegate("callAsync", "async"),
		configurable: true,
		writable: true
	}
});

var Hook_1 = Hook;

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

class HookCodeFactory {
	constructor(config) {
		this.config = config;
		this.options = undefined;
		this._args = undefined;
	}

	create(options) {
		this.init(options);
		let fn;
		switch (this.options.type) {
			case "sync":
				fn = new Function(
					this.args(),
					'"use strict";\n' +
						this.header() +
						this.content({
							onError: err => `throw ${err};\n`,
							onResult: result => `return ${result};\n`,
							resultReturns: true,
							onDone: () => "",
							rethrowIfPossible: true
						})
				);
				break;
			case "async":
				fn = new Function(
					this.args({
						after: "_callback"
					}),
					'"use strict";\n' +
						this.header() +
						this.content({
							onError: err => `_callback(${err});\n`,
							onResult: result => `_callback(null, ${result});\n`,
							onDone: () => "_callback();\n"
						})
				);
				break;
			case "promise":
				let errorHelperUsed = false;
				const content = this.content({
					onError: err => {
						errorHelperUsed = true;
						return `_error(${err});\n`;
					},
					onResult: result => `_resolve(${result});\n`,
					onDone: () => "_resolve();\n"
				});
				let code = "";
				code += '"use strict";\n';
				code += "return new Promise((_resolve, _reject) => {\n";
				if (errorHelperUsed) {
					code += "var _sync = true;\n";
					code += "function _error(_err) {\n";
					code += "if(_sync)\n";
					code += "_resolve(Promise.resolve().then(() => { throw _err; }));\n";
					code += "else\n";
					code += "_reject(_err);\n";
					code += "};\n";
				}
				code += this.header();
				code += content;
				if (errorHelperUsed) {
					code += "_sync = false;\n";
				}
				code += "});\n";
				fn = new Function(this.args(), code);
				break;
		}
		this.deinit();
		return fn;
	}

	setup(instance, options) {
		instance._x = options.taps.map(t => t.fn);
	}

	/**
	 * @param {{ type: "sync" | "promise" | "async", taps: Array<Tap>, interceptors: Array<Interceptor> }} options
	 */
	init(options) {
		this.options = options;
		this._args = options.args.slice();
	}

	deinit() {
		this.options = undefined;
		this._args = undefined;
	}

	header() {
		let code = "";
		if (this.needContext()) {
			code += "var _context = {};\n";
		} else {
			code += "var _context;\n";
		}
		code += "var _x = this._x;\n";
		if (this.options.interceptors.length > 0) {
			code += "var _taps = this.taps;\n";
			code += "var _interceptors = this.interceptors;\n";
		}
		for (let i = 0; i < this.options.interceptors.length; i++) {
			const interceptor = this.options.interceptors[i];
			if (interceptor.call) {
				code += `${this.getInterceptor(i)}.call(${this.args({
					before: interceptor.context ? "_context" : undefined
				})});\n`;
			}
		}
		return code;
	}

	needContext() {
		for (const tap of this.options.taps) if (tap.context) return true;
		return false;
	}

	callTap(tapIndex, { onError, onResult, onDone, rethrowIfPossible }) {
		let code = "";
		let hasTapCached = false;
		for (let i = 0; i < this.options.interceptors.length; i++) {
			const interceptor = this.options.interceptors[i];
			if (interceptor.tap) {
				if (!hasTapCached) {
					code += `var _tap${tapIndex} = ${this.getTap(tapIndex)};\n`;
					hasTapCached = true;
				}
				code += `${this.getInterceptor(i)}.tap(${
					interceptor.context ? "_context, " : ""
				}_tap${tapIndex});\n`;
			}
		}
		code += `var _fn${tapIndex} = ${this.getTapFn(tapIndex)};\n`;
		const tap = this.options.taps[tapIndex];
		switch (tap.type) {
			case "sync":
				if (!rethrowIfPossible) {
					code += `var _hasError${tapIndex} = false;\n`;
					code += "try {\n";
				}
				if (onResult) {
					code += `var _result${tapIndex} = _fn${tapIndex}(${this.args({
						before: tap.context ? "_context" : undefined
					})});\n`;
				} else {
					code += `_fn${tapIndex}(${this.args({
						before: tap.context ? "_context" : undefined
					})});\n`;
				}
				if (!rethrowIfPossible) {
					code += "} catch(_err) {\n";
					code += `_hasError${tapIndex} = true;\n`;
					code += onError("_err");
					code += "}\n";
					code += `if(!_hasError${tapIndex}) {\n`;
				}
				if (onResult) {
					code += onResult(`_result${tapIndex}`);
				}
				if (onDone) {
					code += onDone();
				}
				if (!rethrowIfPossible) {
					code += "}\n";
				}
				break;
			case "async":
				let cbCode = "";
				if (onResult) cbCode += `(_err${tapIndex}, _result${tapIndex}) => {\n`;
				else cbCode += `_err${tapIndex} => {\n`;
				cbCode += `if(_err${tapIndex}) {\n`;
				cbCode += onError(`_err${tapIndex}`);
				cbCode += "} else {\n";
				if (onResult) {
					cbCode += onResult(`_result${tapIndex}`);
				}
				if (onDone) {
					cbCode += onDone();
				}
				cbCode += "}\n";
				cbCode += "}";
				code += `_fn${tapIndex}(${this.args({
					before: tap.context ? "_context" : undefined,
					after: cbCode
				})});\n`;
				break;
			case "promise":
				code += `var _hasResult${tapIndex} = false;\n`;
				code += `var _promise${tapIndex} = _fn${tapIndex}(${this.args({
					before: tap.context ? "_context" : undefined
				})});\n`;
				code += `if (!_promise${tapIndex} || !_promise${tapIndex}.then)\n`;
				code += `  throw new Error('Tap function (tapPromise) did not return promise (returned ' + _promise${tapIndex} + ')');\n`;
				code += `_promise${tapIndex}.then(_result${tapIndex} => {\n`;
				code += `_hasResult${tapIndex} = true;\n`;
				if (onResult) {
					code += onResult(`_result${tapIndex}`);
				}
				if (onDone) {
					code += onDone();
				}
				code += `}, _err${tapIndex} => {\n`;
				code += `if(_hasResult${tapIndex}) throw _err${tapIndex};\n`;
				code += onError(`_err${tapIndex}`);
				code += "});\n";
				break;
		}
		return code;
	}

	callTapsSeries({
		onError,
		onResult,
		resultReturns,
		onDone,
		doneReturns,
		rethrowIfPossible
	}) {
		if (this.options.taps.length === 0) return onDone();
		const firstAsync = this.options.taps.findIndex(t => t.type !== "sync");
		const somethingReturns = resultReturns || doneReturns || false;
		let code = "";
		let current = onDone;
		for (let j = this.options.taps.length - 1; j >= 0; j--) {
			const i = j;
			const unroll = current !== onDone && this.options.taps[i].type !== "sync";
			if (unroll) {
				code += `function _next${i}() {\n`;
				code += current();
				code += `}\n`;
				current = () => `${somethingReturns ? "return " : ""}_next${i}();\n`;
			}
			const done = current;
			const doneBreak = skipDone => {
				if (skipDone) return "";
				return onDone();
			};
			const content = this.callTap(i, {
				onError: error => onError(i, error, done, doneBreak),
				onResult:
					onResult &&
					(result => {
						return onResult(i, result, done, doneBreak);
					}),
				onDone: !onResult && done,
				rethrowIfPossible:
					rethrowIfPossible && (firstAsync < 0 || i < firstAsync)
			});
			current = () => content;
		}
		code += current();
		return code;
	}

	callTapsLooping({ onError, onDone, rethrowIfPossible }) {
		if (this.options.taps.length === 0) return onDone();
		const syncOnly = this.options.taps.every(t => t.type === "sync");
		let code = "";
		if (!syncOnly) {
			code += "var _looper = () => {\n";
			code += "var _loopAsync = false;\n";
		}
		code += "var _loop;\n";
		code += "do {\n";
		code += "_loop = false;\n";
		for (let i = 0; i < this.options.interceptors.length; i++) {
			const interceptor = this.options.interceptors[i];
			if (interceptor.loop) {
				code += `${this.getInterceptor(i)}.loop(${this.args({
					before: interceptor.context ? "_context" : undefined
				})});\n`;
			}
		}
		code += this.callTapsSeries({
			onError,
			onResult: (i, result, next, doneBreak) => {
				let code = "";
				code += `if(${result} !== undefined) {\n`;
				code += "_loop = true;\n";
				if (!syncOnly) code += "if(_loopAsync) _looper();\n";
				code += doneBreak(true);
				code += `} else {\n`;
				code += next();
				code += `}\n`;
				return code;
			},
			onDone:
				onDone &&
				(() => {
					let code = "";
					code += "if(!_loop) {\n";
					code += onDone();
					code += "}\n";
					return code;
				}),
			rethrowIfPossible: rethrowIfPossible && syncOnly
		});
		code += "} while(_loop);\n";
		if (!syncOnly) {
			code += "_loopAsync = true;\n";
			code += "};\n";
			code += "_looper();\n";
		}
		return code;
	}

	callTapsParallel({
		onError,
		onResult,
		onDone,
		rethrowIfPossible,
		onTap = (i, run) => run()
	}) {
		if (this.options.taps.length <= 1) {
			return this.callTapsSeries({
				onError,
				onResult,
				onDone,
				rethrowIfPossible
			});
		}
		let code = "";
		code += "do {\n";
		code += `var _counter = ${this.options.taps.length};\n`;
		if (onDone) {
			code += "var _done = () => {\n";
			code += onDone();
			code += "};\n";
		}
		for (let i = 0; i < this.options.taps.length; i++) {
			const done = () => {
				if (onDone) return "if(--_counter === 0) _done();\n";
				else return "--_counter;";
			};
			const doneBreak = skipDone => {
				if (skipDone || !onDone) return "_counter = 0;\n";
				else return "_counter = 0;\n_done();\n";
			};
			code += "if(_counter <= 0) break;\n";
			code += onTap(
				i,
				() =>
					this.callTap(i, {
						onError: error => {
							let code = "";
							code += "if(_counter > 0) {\n";
							code += onError(i, error, done, doneBreak);
							code += "}\n";
							return code;
						},
						onResult:
							onResult &&
							(result => {
								let code = "";
								code += "if(_counter > 0) {\n";
								code += onResult(i, result, done, doneBreak);
								code += "}\n";
								return code;
							}),
						onDone:
							!onResult &&
							(() => {
								return done();
							}),
						rethrowIfPossible
					}),
				done,
				doneBreak
			);
		}
		code += "} while(false);\n";
		return code;
	}

	args({ before, after } = {}) {
		let allArgs = this._args;
		if (before) allArgs = [before].concat(allArgs);
		if (after) allArgs = allArgs.concat(after);
		if (allArgs.length === 0) {
			return "";
		} else {
			return allArgs.join(", ");
		}
	}

	getTapFn(idx) {
		return `_x[${idx}]`;
	}

	getTap(idx) {
		return `_taps[${idx}]`;
	}

	getInterceptor(idx) {
		return `_interceptors[${idx}]`;
	}
}

var HookCodeFactory_1 = HookCodeFactory;

class SyncBailHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onResult, resultReturns, onDone, rethrowIfPossible }) {
		return this.callTapsSeries({
			onError: (i, err) => onError(err),
			onResult: (i, result, next) =>
				`if(${result} !== undefined) {\n${onResult(
					result
				)};\n} else {\n${next()}}\n`,
			resultReturns,
			onDone,
			rethrowIfPossible
		});
	}
}

const factory = new SyncBailHookCodeFactory();

class SyncBailHook extends Hook_1 {
	tapAsync() {
		throw new Error("tapAsync is not supported on a SyncBailHook");
	}

	tapPromise() {
		throw new Error("tapPromise is not supported on a SyncBailHook");
	}

	compile(options) {
		factory.setup(this, options);
		return factory.create(options);
	}
}

var SyncBailHook_1 = SyncBailHook;

function Tapable() {
	this._pluginCompat = new SyncBailHook_1(["options"]);
	this._pluginCompat.tap(
		{
			name: "Tapable camelCase",
			stage: 100
		},
		options => {
			options.names.add(
				options.name.replace(/[- ]([a-z])/g, (str, ch) => ch.toUpperCase())
			);
		}
	);
	this._pluginCompat.tap(
		{
			name: "Tapable this.hooks",
			stage: 200
		},
		options => {
			let hook;
			for (const name of options.names) {
				hook = this.hooks[name];
				if (hook !== undefined) {
					break;
				}
			}
			if (hook !== undefined) {
				const tapOpt = {
					name: options.fn.name || "unnamed compat plugin",
					stage: options.stage || 0
				};
				if (options.async) hook.tapAsync(tapOpt, options.fn);
				else hook.tap(tapOpt, options.fn);
				return true;
			}
		}
	);
}
var Tapable_1 = Tapable;

Tapable.addCompatLayer = function addCompatLayer(instance) {
	Tapable.call(instance);
	instance.plugin = Tapable.prototype.plugin;
	instance.apply = Tapable.prototype.apply;
};

Tapable.prototype.plugin = util.deprecate(function plugin(name, fn) {
	if (Array.isArray(name)) {
		name.forEach(function(name) {
			this.plugin(name, fn);
		}, this);
		return;
	}
	const result = this._pluginCompat.call({
		name: name,
		fn: fn,
		names: new Set([name])
	});
	if (!result) {
		throw new Error(
			`Plugin could not be registered at '${name}'. Hook was not found.\n` +
				"BREAKING CHANGE: There need to exist a hook at 'this.hooks'. " +
				"To create a compatibility layer for this hook, hook into 'this._pluginCompat'."
		);
	}
}, "Tapable.plugin is deprecated. Use new API on `.hooks` instead");

Tapable.prototype.apply = util.deprecate(function apply() {
	for (var i = 0; i < arguments.length; i++) {
		arguments[i].apply(this);
	}
}, "Tapable.apply is deprecated. Call apply on the plugin directly instead");

class SyncHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onDone, rethrowIfPossible }) {
		return this.callTapsSeries({
			onError: (i, err) => onError(err),
			onDone,
			rethrowIfPossible
		});
	}
}

const factory$1 = new SyncHookCodeFactory();

class SyncHook extends Hook_1 {
	tapAsync() {
		throw new Error("tapAsync is not supported on a SyncHook");
	}

	tapPromise() {
		throw new Error("tapPromise is not supported on a SyncHook");
	}

	compile(options) {
		factory$1.setup(this, options);
		return factory$1.create(options);
	}
}

var SyncHook_1 = SyncHook;

class SyncWaterfallHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onResult, resultReturns, rethrowIfPossible }) {
		return this.callTapsSeries({
			onError: (i, err) => onError(err),
			onResult: (i, result, next) => {
				let code = "";
				code += `if(${result} !== undefined) {\n`;
				code += `${this._args[0]} = ${result};\n`;
				code += `}\n`;
				code += next();
				return code;
			},
			onDone: () => onResult(this._args[0]),
			doneReturns: resultReturns,
			rethrowIfPossible
		});
	}
}

const factory$2 = new SyncWaterfallHookCodeFactory();

class SyncWaterfallHook extends Hook_1 {
	constructor(args) {
		super(args);
		if (args.length < 1)
			throw new Error("Waterfall hooks must have at least one argument");
	}

	tapAsync() {
		throw new Error("tapAsync is not supported on a SyncWaterfallHook");
	}

	tapPromise() {
		throw new Error("tapPromise is not supported on a SyncWaterfallHook");
	}

	compile(options) {
		factory$2.setup(this, options);
		return factory$2.create(options);
	}
}

var SyncWaterfallHook_1 = SyncWaterfallHook;

class SyncLoopHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onDone, rethrowIfPossible }) {
		return this.callTapsLooping({
			onError: (i, err) => onError(err),
			onDone,
			rethrowIfPossible
		});
	}
}

const factory$3 = new SyncLoopHookCodeFactory();

class SyncLoopHook extends Hook_1 {
	tapAsync() {
		throw new Error("tapAsync is not supported on a SyncLoopHook");
	}

	tapPromise() {
		throw new Error("tapPromise is not supported on a SyncLoopHook");
	}

	compile(options) {
		factory$3.setup(this, options);
		return factory$3.create(options);
	}
}

var SyncLoopHook_1 = SyncLoopHook;

class AsyncParallelHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onDone }) {
		return this.callTapsParallel({
			onError: (i, err, done, doneBreak) => onError(err) + doneBreak(true),
			onDone
		});
	}
}

const factory$4 = new AsyncParallelHookCodeFactory();

class AsyncParallelHook extends Hook_1 {
	compile(options) {
		factory$4.setup(this, options);
		return factory$4.create(options);
	}
}

Object.defineProperties(AsyncParallelHook.prototype, {
	_call: { value: undefined, configurable: true, writable: true }
});

var AsyncParallelHook_1 = AsyncParallelHook;

class AsyncParallelBailHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onResult, onDone }) {
		let code = "";
		code += `var _results = new Array(${this.options.taps.length});\n`;
		code += "var _checkDone = () => {\n";
		code += "for(var i = 0; i < _results.length; i++) {\n";
		code += "var item = _results[i];\n";
		code += "if(item === undefined) return false;\n";
		code += "if(item.result !== undefined) {\n";
		code += onResult("item.result");
		code += "return true;\n";
		code += "}\n";
		code += "if(item.error) {\n";
		code += onError("item.error");
		code += "return true;\n";
		code += "}\n";
		code += "}\n";
		code += "return false;\n";
		code += "}\n";
		code += this.callTapsParallel({
			onError: (i, err, done, doneBreak) => {
				let code = "";
				code += `if(${i} < _results.length && ((_results.length = ${i +
					1}), (_results[${i}] = { error: ${err} }), _checkDone())) {\n`;
				code += doneBreak(true);
				code += "} else {\n";
				code += done();
				code += "}\n";
				return code;
			},
			onResult: (i, result, done, doneBreak) => {
				let code = "";
				code += `if(${i} < _results.length && (${result} !== undefined && (_results.length = ${i +
					1}), (_results[${i}] = { result: ${result} }), _checkDone())) {\n`;
				code += doneBreak(true);
				code += "} else {\n";
				code += done();
				code += "}\n";
				return code;
			},
			onTap: (i, run, done, doneBreak) => {
				let code = "";
				if (i > 0) {
					code += `if(${i} >= _results.length) {\n`;
					code += done();
					code += "} else {\n";
				}
				code += run();
				if (i > 0) code += "}\n";
				return code;
			},
			onDone
		});
		return code;
	}
}

const factory$5 = new AsyncParallelBailHookCodeFactory();

class AsyncParallelBailHook extends Hook_1 {
	compile(options) {
		factory$5.setup(this, options);
		return factory$5.create(options);
	}
}

Object.defineProperties(AsyncParallelBailHook.prototype, {
	_call: { value: undefined, configurable: true, writable: true }
});

var AsyncParallelBailHook_1 = AsyncParallelBailHook;

class AsyncSeriesHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onDone }) {
		return this.callTapsSeries({
			onError: (i, err, next, doneBreak) => onError(err) + doneBreak(true),
			onDone
		});
	}
}

const factory$6 = new AsyncSeriesHookCodeFactory();

class AsyncSeriesHook extends Hook_1 {
	compile(options) {
		factory$6.setup(this, options);
		return factory$6.create(options);
	}
}

Object.defineProperties(AsyncSeriesHook.prototype, {
	_call: { value: undefined, configurable: true, writable: true }
});

var AsyncSeriesHook_1 = AsyncSeriesHook;

class AsyncSeriesBailHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onResult, resultReturns, onDone }) {
		return this.callTapsSeries({
			onError: (i, err, next, doneBreak) => onError(err) + doneBreak(true),
			onResult: (i, result, next) =>
				`if(${result} !== undefined) {\n${onResult(
					result
				)};\n} else {\n${next()}}\n`,
			resultReturns,
			onDone
		});
	}
}

const factory$7 = new AsyncSeriesBailHookCodeFactory();

class AsyncSeriesBailHook extends Hook_1 {
	compile(options) {
		factory$7.setup(this, options);
		return factory$7.create(options);
	}
}

Object.defineProperties(AsyncSeriesBailHook.prototype, {
	_call: { value: undefined, configurable: true, writable: true }
});

var AsyncSeriesBailHook_1 = AsyncSeriesBailHook;

class AsyncSeriesWaterfallHookCodeFactory extends HookCodeFactory_1 {
	content({ onError, onResult, onDone }) {
		return this.callTapsSeries({
			onError: (i, err, next, doneBreak) => onError(err) + doneBreak(true),
			onResult: (i, result, next) => {
				let code = "";
				code += `if(${result} !== undefined) {\n`;
				code += `${this._args[0]} = ${result};\n`;
				code += `}\n`;
				code += next();
				return code;
			},
			onDone: () => onResult(this._args[0])
		});
	}
}

const factory$8 = new AsyncSeriesWaterfallHookCodeFactory();

class AsyncSeriesWaterfallHook extends Hook_1 {
	constructor(args) {
		super(args);
		if (args.length < 1)
			throw new Error("Waterfall hooks must have at least one argument");
	}

	compile(options) {
		factory$8.setup(this, options);
		return factory$8.create(options);
	}
}

Object.defineProperties(AsyncSeriesWaterfallHook.prototype, {
	_call: { value: undefined, configurable: true, writable: true }
});

var AsyncSeriesWaterfallHook_1 = AsyncSeriesWaterfallHook;

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

class HookMap {
	constructor(factory) {
		this._map = new Map();
		this._factory = factory;
		this._interceptors = [];
	}

	get(key) {
		return this._map.get(key);
	}

	for(key) {
		const hook = this.get(key);
		if (hook !== undefined) {
			return hook;
		}
		let newHook = this._factory(key);
		const interceptors = this._interceptors;
		for (let i = 0; i < interceptors.length; i++) {
			newHook = interceptors[i].factory(key, newHook);
		}
		this._map.set(key, newHook);
		return newHook;
	}

	intercept(interceptor) {
		this._interceptors.push(
			Object.assign(
				{
					factory: (key, hook) => hook
				},
				interceptor
			)
		);
	}

	tap(key, options, fn) {
		return this.for(key).tap(options, fn);
	}

	tapAsync(key, options, fn) {
		return this.for(key).tapAsync(options, fn);
	}

	tapPromise(key, options, fn) {
		return this.for(key).tapPromise(options, fn);
	}
}

var HookMap_1 = HookMap;

class MultiHook {
	constructor(hooks) {
		this.hooks = hooks;
	}

	tap(options, fn) {
		for (const hook of this.hooks) {
			hook.tap(options, fn);
		}
	}

	tapAsync(options, fn) {
		for (const hook of this.hooks) {
			hook.tapAsync(options, fn);
		}
	}

	tapPromise(options, fn) {
		for (const hook of this.hooks) {
			hook.tapPromise(options, fn);
		}
	}

	isUsed() {
		for (const hook of this.hooks) {
			if (hook.isUsed()) return true;
		}
		return false;
	}

	intercept(interceptor) {
		for (const hook of this.hooks) {
			hook.intercept(interceptor);
		}
	}

	withOptions(options) {
		return new MultiHook(this.hooks.map(h => h.withOptions(options)));
	}
}

var MultiHook_1 = MultiHook;

var lib = createCommonjsModule(function (module, exports) {

exports.__esModule = true;
exports.Tapable = Tapable_1;
exports.SyncHook = SyncHook_1;
exports.SyncBailHook = SyncBailHook_1;
exports.SyncWaterfallHook = SyncWaterfallHook_1;
exports.SyncLoopHook = SyncLoopHook_1;
exports.AsyncParallelHook = AsyncParallelHook_1;
exports.AsyncParallelBailHook = AsyncParallelBailHook_1;
exports.AsyncSeriesHook = AsyncSeriesHook_1;
exports.AsyncSeriesBailHook = AsyncSeriesBailHook_1;
exports.AsyncSeriesWaterfallHook = AsyncSeriesWaterfallHook_1;
exports.HookMap = HookMap_1;
exports.MultiHook = MultiHook_1;
});

unwrapExports(lib);
var lib_1 = lib.Tapable;
var lib_2 = lib.SyncHook;
var lib_3 = lib.SyncBailHook;
var lib_4 = lib.SyncWaterfallHook;
var lib_5 = lib.SyncLoopHook;
var lib_6 = lib.AsyncParallelHook;
var lib_7 = lib.AsyncParallelBailHook;
var lib_8 = lib.AsyncSeriesHook;
var lib_9 = lib.AsyncSeriesBailHook;
var lib_10 = lib.AsyncSeriesWaterfallHook;
var lib_11 = lib.HookMap;
var lib_12 = lib.MultiHook;

function debugHooks(obj, includes) {
    return new Proxy(obj, {
        get: function (target, name, receiver) {
            if (name === 'tap' &&
                target[name] &&
                typeof target[name] === 'function') {
                return function (option, func) {
                    var newF = function () {
                        var rest = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            rest[_i] = arguments[_i];
                        }
                        var methodName = option;
                        console.group(methodName);
                        console.log.apply(console, __spread(rest));
                        console.groupEnd();
                        return func.apply(void 0, __spread(rest));
                    };
                    return target[name](option, newF);
                };
            }
            else if (target[name] !== null &&
                typeof target[name] === 'object' &&
                includes.includes(name)) {
                return debugHooks(target[name], includes);
            }
            else {
                return Reflect.get(target, name, receiver);
            }
        },
    });
}

function isMenuGroup(item) {
    if (item.subs) {
        return true;
    }
    return false;
}
var HooksProvider = /** @class */ (function () {
    function HooksProvider(plugins, logHooks) {
        var _this = this;
        this.hooks = {
            afterMenusFetched: new lib_2(['appKey', 'menus']),
            afterPageLoaded: new lib_2(['appKey', 'pageKey', 'props']),
            afterPageUnloaded: new lib_2(['appKey', 'pageKey', 'props']),
            afterComponentLoaded: new lib_2([
                'appKey',
                'pageKey',
                'compnent',
                'props',
            ]),
            afterComponentUnloaded: new lib_2([
                'appKey',
                'pageKey',
                'compnent',
                'props',
            ]),
            afterFormSelectFetched: new lib_2([
                'appKey',
                'pageKey',
                'formKey',
                'formItems',
                'selectKey',
                'selectData',
            ]),
            afterTableDataSourceFetched: new lib_2([
                'appKey',
                'pageKey',
                'tableKey',
                'column',
                'dataSource',
            ]),
            beforeFormSelectFetched: new lib_2([
                'appKey',
                'pageKey',
                'formKey',
                'formItems',
                'selectKey',
            ]),
            beforeTableDataSourceFetched: new lib_2([
                'appKey',
                'pageKey',
                'tableKey',
                'columns',
            ]),
            beforeTableColumnFinalization: new lib_2([
                'appKey',
                'pageKey',
                'column',
            ]),
            beforeButtonClick: new lib_2(['appKey', 'pageKey', 'buttonKey']),
            beforeFormSubmit: new lib_2(['appKey', 'pageKey', 'formKey', 'values'])
        };
        if (Array.isArray(plugins)) {
            plugins.forEach(function (plugin) {
                if (logHooks && logHooks.length > 0) {
                    plugin.apply(debugHooks(_this.hooks, logHooks));
                }
                else {
                    plugin.apply(_this.hooks);
                }
            });
        }
    }
    return HooksProvider;
}());
var initialConfig = {
    appKey: 'YOUR_APP_KEY',
    appTitle: 'YOUR_APP_TITLE',
    menus: []
};
var common = { config: initialConfig, hooks: new HooksProvider([]).hooks };
var App = React.createContext(common);
function AppProvider(props) {
    return React.createElement(App.Provider, { value: { config: props.config, hooks: new HooksProvider(props.plugins, props.debugHooks).hooks } }, props.children);
}

function createContainer(useHook) {
    var Context = React.createContext(null);
    function Provider(props) {
        var value = useHook(props.initialState);
        return React.createElement(Context.Provider, { value: value }, props.children);
    }
    function useContainer() {
        var value = React.useContext(Context);
        if (value === null) {
            throw new Error("Component must be wrapped with <Container.Provider>");
        }
        return value;
    }
    return { Provider: Provider, useContainer: useContainer };
}

function useIndicator() {
    var _a = __read(React.useState(null), 2), error = _a[0], setError = _a[1];
    var _b = __read(React.useState(null), 2), warning = _b[0], setWarning = _b[1];
    var _c = __read(React.useState(null), 2), success = _c[0], _setSuccess = _c[1];
    var _d = __read(React.useState(null), 2), info = _d[0], _setInfo = _d[1];
    var _e = __read(React.useState(0), 2), requestQuantity = _e[0], _setRequestQuantity = _e[1];
    var clearSuccess = function () { return _setSuccess(null); };
    var clearInfo = function () { return _setInfo(null); };
    var clearWarning = function () { return setWarning(null); };
    var clearError = function () { return setError(null); };
    var clearRequest = function () { return _setRequestQuantity(0); };
    var setSuccess = function (message) {
        _setSuccess(message);
        setTimeout(function () {
            clearSuccess();
        }, 3000);
    };
    var setInfo = function (message) {
        _setInfo(message);
        setTimeout(function () {
            clearInfo();
        }, 3000);
    };
    var startRequest = function () {
        _setRequestQuantity(requestQuantity + 1);
    };
    var endRequest = function () {
        _setRequestQuantity(requestQuantity - 1);
    };
    return {
        error: error,
        warning: warning,
        success: success,
        info: info,
        requestQuantity: requestQuantity,
        setError: setError,
        setWarning: setWarning,
        setSuccess: setSuccess,
        setInfo: setInfo,
        clearError: clearError,
        clearInfo: clearInfo,
        clearSuccess: clearSuccess,
        clearWarning: clearWarning,
        startRequest: startRequest,
        endRequest: endRequest,
        clearRequest: clearRequest
    };
}

function useFilter() {
    var _a = __read(React.useState({}), 2), _filter = _a[0], _setFilter = _a[1];
    var getFilter = function (pageKey, tableKey) {
        var f = _filter[pageKey + "_" + tableKey];
        return f;
    };
    var setFilter = function (pageKey, tableKey, values) {
        var _a;
        _setFilter(__assign({}, _filter, (_a = {}, _a[pageKey + "_" + tableKey] = values, _a)));
    };
    return { getFilter: getFilter, setFilter: setFilter };
}

function useModal() {
    var _a = __read(React.useState({}), 2), _modalShow = _a[0], _setModalShow = _a[1];
    var isShowModal = function (pageKey, modalKey) {
        var f = _modalShow[pageKey + "_" + modalKey];
        return f;
    };
    var hideModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = false, _a)));
    };
    var showModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = true, _a)));
    };
    return { isShowModal: isShowModal, hideModal: hideModal, showModal: showModal };
}

function usePage() {
    var indicator = useIndicator();
    var filter = useFilter();
    var modal = useModal();
    return __assign({}, indicator, filter, modal);
}

var Pages = createContainer(usePage);

function Alert(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'alert', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'alert', props);
        };
    }, []);
    return (React.createElement("k_alert", { type: props.type, message: props.message, description: props.description, onClose: props.onClose }));
}

function Alert$1(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'loading', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'loading', props);
        };
    }, []);
    return (React.createElement("k_loading", { show: props.show, type: props.type, timeout: props.timeout }));
}

function Indicator() {
    var _a = Pages.useContainer(), error = _a.error, warning = _a.warning, success = _a.success, info = _a.info, requestQuantity = _a.requestQuantity, clearError = _a.clearError, clearInfo = _a.clearInfo, clearSuccess = _a.clearSuccess, clearWarning = _a.clearWarning, clearRequest = _a.clearRequest;
    var errorAlert = error && (React.createElement(Alert, { type: "error", message: error.code ? '操作失败' : '发生错误', description: error.message || JSON.stringify(error), onClose: clearError }));
    var warningAlert = warning && (React.createElement(Alert, { type: "warning", message: warning.title, description: warning.message, onClose: clearWarning }));
    var infoAlert = info && (React.createElement(Alert, { type: "info", message: info.title, description: info.message, onClose: clearInfo }));
    var successAlert = success && (React.createElement(Alert, { type: "success", message: success.title, description: success.message, onClose: clearSuccess }));
    return (React.createElement(React.Fragment, null,
        errorAlert,
        warningAlert,
        infoAlert,
        successAlert,
        React.createElement(Alert$1, { show: requestQuantity > 0, type: "overall", timeout: clearRequest })));
}

function Page(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'page', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'page', props);
        };
    }, []);
    return (React.createElement("k_page", { style: __assign({}, props.style) },
        props.children,
        React.createElement(Indicator, null)));
}

var href = window.location.href;
function fetch2(url, options, loginUrl) {
    if (loginUrl === void 0) { loginUrl = 'https://docoder.com'; }
    var realUrl = url;
    var opt = options || {};
    opt.credentials = opt.credentials || 'include';
    return fetch(realUrl, opt)
        .then(function (response) { return response.json(); })
        .then(function (json) {
        if (json.code === 40003 || json.code === 201 || json.code === 401) {
            var return_login = loginUrl + '?returnUrl=' + encodeURIComponent(href);
            window.location.replace(return_login);
            throw new Error('Please Login First!');
        }
        else {
            return json;
        }
    });
}
function GET(url, loginUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('get', url, loginUrl)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_1 = _a.sent();
                    throw error_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function POST(url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('post', url, loginUrl, body)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_2 = _a.sent();
                    throw error_2;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function REQ(method, url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var data, error_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetch2(url, method === 'post' ? {
                            method: 'POST',
                            headers: {
                                'Accept': 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify(body),
                        } : null, loginUrl)];
                case 1:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 2:
                    error_3 = _a.sent();
                    throw error_3;
                case 3: return [2 /*return*/];
            }
        });
    });
}

function useGET() {
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    function send(url, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var u, paramsStr_1, data, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        startRequest();
                        u = url;
                        if (filter && Object.keys(filter).length > 0) {
                            paramsStr_1 = '?';
                            Object.keys(filter).forEach(function (k) {
                                paramsStr_1 += k + "=" + filter[k] + "&";
                            });
                            u = "" + url + paramsStr_1.slice(0, -1);
                        }
                        return [4 /*yield*/, GET(u, app.config.loginUrl)];
                    case 1:
                        data = _a.sent();
                        endRequest();
                        //TODO: DOC
                        if (data.code === 0 && data.data) {
                            return [2 /*return*/, data];
                        }
                        else {
                            setError(data);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        setError(error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/, null];
                }
            });
        });
    }
    return { send: send };
}

function useTable(pageKey, tableKey, columns, meta) {
    var app = React.useContext(App);
    var send = useGET().send;
    var filter = Pages.useContainer().getFilter(pageKey, tableKey);
    var type = "TABLE_DATA_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: [] }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        function fetchTableData(p, t, u) {
            return __awaiter(this, void 0, void 0, function () {
                var dataSource, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            app.hooks.beforeTableDataSourceFetched.call(app.config.appKey, p, t, columns);
                            if (!meta.data) return [3 /*break*/, 1];
                            _a = meta.data.filter(function (d) {
                                if (!filter || !filter.type)
                                    return true;
                                else
                                    return d.typeId === filter.type;
                            });
                            return [3 /*break*/, 3];
                        case 1: return [4 /*yield*/, send(u, filter)];
                        case 2:
                            _a = _b.sent();
                            _b.label = 3;
                        case 3:
                            dataSource = _a;
                            app.hooks.afterTableDataSourceFetched.call(app.config.appKey, p, t, columns, dataSource);
                            if (dataSource && dataSource.length > 0) {
                                dispatch({ type: type, data: dataSource });
                            }
                            return [2 /*return*/];
                    }
                });
            });
        }
        fetchTableData(pageKey, tableKey, meta.url);
    }, [pageKey, meta.url, filter]);
    return state.data;
}

function Table(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'table', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'table', props);
        };
    }, []);
    var keyItem = props.columns.find(function (c) { return !!c.id; });
    var rowKey = keyItem ? keyItem.key : 'key';
    var columns = props.columns.map(function (c) {
        app.hooks.beforeTableColumnFinalization.call(app.config.appKey, props.pageKey, c);
        return __assign({}, c, { dataIndex: c.key, title: c.label });
    });
    var dataSource = useTable(props.pageKey, props.tableKey, columns, props.meta);
    return (React.createElement("k_table", { style: __assign({}, props.style), appKey: app.config.appKey, pageKey: props.pageKey, className: props.className, rowKey: rowKey, columns: columns, dataSource: dataSource }));
}
Table.defaultProps = {
    method: 'GET',
};

function useSelect(pageKey, formKey, items) {
    var app = React.useContext(App);
    var send = useGET().send;
    var type = 'SELECT_DATA_FETCHED';
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: items }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        function fetchSelectData(p, f, k, u) {
            return __awaiter(this, void 0, void 0, function () {
                var data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            app.hooks.beforeFormSelectFetched.call(app.config.appKey, p, f, items, k);
                            return [4 /*yield*/, send(u)];
                        case 1:
                            data = (_a.sent()) || [];
                            app.hooks.afterFormSelectFetched.call(app.config.appKey, p, f, items, k, data);
                            return [2 /*return*/, data];
                    }
                });
            });
        }
        function handleSelect(pp, ff, itms) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, Promise.all(itms.filter(function (i) { return i.type === 'select'; })
                                .map(function (i) { return __awaiter(_this, void 0, void 0, function () {
                                var _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            if (!(i.meta && i.meta.data)) return [3 /*break*/, 1];
                                            return [2 /*return*/, i];
                                        case 1:
                                            if (!(i.meta && i.meta.url)) return [3 /*break*/, 3];
                                            _a = i.meta;
                                            return [4 /*yield*/, fetchSelectData(pp, ff, i.key, i.meta.url)];
                                        case 2:
                                            _a.data = _b.sent();
                                            return [2 /*return*/, i];
                                        case 3: throw new Error('The JSON format is not valid!');
                                    }
                                });
                            }); }))];
                        case 1:
                            _a.sent();
                            dispatch({ type: type, data: itms });
                            return [2 /*return*/];
                    }
                });
            });
        }
        handleSelect(pageKey, formKey, items);
    }, [pageKey, formKey, items]);
    return state.data;
}

function usePOST() {
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    function send(url, body) {
        return __awaiter(this, void 0, void 0, function () {
            var data, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        startRequest();
                        return [4 /*yield*/, POST(url, app.config.loginUrl, body)];
                    case 1:
                        data = _a.sent();
                        endRequest();
                        //TODO: DOC
                        if (data.code === 0 && data.data) {
                            return [2 /*return*/, data];
                        }
                        else {
                            setError(data);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        setError(error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/, null];
                }
            });
        });
    }
    return { send: send };
}

function useSubmit(url, method, pageKey, modalKey) {
    var get = useGET();
    var post = usePOST();
    var hideModal = Pages.useContainer().hideModal;
    function send(values) {
        var result = null;
        if (method && method.toLowerCase() === 'post') {
            result = post.send(url, values);
        }
        else {
            result = get.send(url, values);
        }
        if (result && modalKey) {
            hideModal(pageKey, modalKey);
        }
    }
    return { send: send };
}

function Form(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'form', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'form', props);
        };
    }, []);
    var items = useSelect(props.pageKey, props.formKey, props.items);
    var setFilter = Pages.useContainer().setFilter;
    var send = useSubmit(props.meta.url, props.meta.method, props.pageKey, props.meta.modal).send;
    return (React.createElement("k_form", { style: __assign({}, props.style), inModal: props.meta.modal && props.meta.modal.length > 0, className: props.className, items: items, onSubmit: function (values) {
            app.hooks.beforeFormSubmit.call(app.config.appKey, props.pageKey, props.formKey);
            if (props.meta.filter) {
                setFilter(props.pageKey, props.meta.filter, values);
            }
            else {
                send(values);
            }
        } }));
}
Form.defaultProps = {
    method: 'POST',
};

function Buttons(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'button', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'button', props);
        };
    }, []);
    var showModal = Pages.useContainer().showModal;
    return (React.createElement("k_button", __assign({ style: __assign({}, props.style) }, props.meta, { onClick: function () {
            app.hooks.beforeButtonClick.call(app.config.appKey, props.pageKey, props.buttonKey);
            if (props.meta.modal && props.meta.modal.length > 0) {
                showModal(props.pageKey, props.meta.modal);
            }
        } })));
}

function Page$1(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'modal', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'modal', props);
        };
    }, []);
    var _a = Pages.useContainer(), hideModal = _a.hideModal, isShowModal = _a.isShowModal;
    return (React.createElement("k_modal", { style: { display: 'none' }, visible: isShowModal(props.pageKey, props.modalKey), title: props.title, width: props.width, onCancel: function () {
            hideModal(props.pageKey, props.modalKey);
        } },
        React.createElement(Pages.Provider, null,
            React.createElement(Stack, { pageKey: props.pageKey, items: props.contens, direction: "vertical", stackKey: props.pageKey + "_" + props.modalKey + "_main_stack" }))));
}

function Stack(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'stack', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'stack', props);
        };
    }, []);
    var vertical = props.direction === 'vertical';
    return (React.createElement("div", { style: __assign({ display: 'flex', flexDirection: vertical ? 'column' : 'row' }, vertical ? { marginBottom: '-20px' } : { marginRight: '-10px' }, props.style) }, props.items.map(function (c) {
        switch (c.type) {
            case 'Table':
                return (React.createElement(Table, { pageKey: props.pageKey, tableKey: c.key, style: vertical ? { marginBottom: 20 } : { marginRight: 10 }, key: c.key, columns: c.items, meta: c.meta }));
            case 'Form':
                return (React.createElement(Form, { pageKey: props.pageKey, formKey: c.key, style: vertical ? { marginBottom: 20 } : { marginRight: 10 }, key: c.key, items: c.items, meta: c.meta }));
            case 'Stack':
                return (React.createElement(Stack, { key: c.key, pageKey: props.pageKey, stackKey: c.key, items: c.items, direction: c.meta.direction, style: vertical ? { marginBottom: 20 } : { marginRight: 10 } }));
            case 'Button':
                return (React.createElement(Buttons, { key: c.key, pageKey: props.pageKey, buttonKey: c.key, meta: c.meta, style: vertical ? { marginBottom: 20 } : { marginRight: 10 } }));
            case 'Modal':
                return (React.createElement(Page$1, { key: c.key, pageKey: props.pageKey, modalKey: c.key, contens: c.items, title: c.meta.label, width: c.meta.width }));
            default:
                return null;
        }
    })));
}

function inIframe() {
    try {
        return window.self !== window.top;
    }
    catch (e) {
        return true;
    }
}

function Index(props) {
    var hide = inIframe();
    var config = props.config;
    var plugins = props.plugins;
    var debugHooks = props.debugHooks;
    return (React.createElement(Layout, { config: config, plugins: plugins, debugHooks: debugHooks, hide: hide }));
}

function PageContainer(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterPageLoaded.call(app.config.appKey, pageKey, props);
        return function () {
            app.hooks.afterPageUnloaded.call(app.config.appKey, pageKey, props);
        };
    }, []);
    var send = useGET().send;
    var type = "PAGE_JSON_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: [] }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        function fetchPageJson(url) {
            return __awaiter(this, void 0, void 0, function () {
                var data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, send(url)];
                        case 1:
                            data = _a.sent();
                            dispatch({ type: type, data: data });
                            return [2 /*return*/];
                    }
                });
            });
        }
        if (props.pageJSON && props.pageJSON.length > 0) {
            dispatch({ type: type, data: props.pageJSON });
        }
        else if (props.pageAPI) {
            fetchPageJson(props.pageAPI + "?page=" + props.pageKey);
        }
    }, []);
    var pageKey = props.pageKey;
    return (React.createElement(Page, { pageKey: pageKey, style: { padding: 20, background: 'white' } },
        React.createElement(Stack, { pageKey: pageKey, items: state.data, direction: "vertical", stackKey: pageKey + "_main_stack" })));
}

function isEntryPropsWithAPI(item) {
    if (item.pageAPI) {
        return true;
    }
    return false;
}
function Entry(props) {
    var config = props.config, plugins = props.plugins, pageKey = props.pageKey, debugHooks = props.debugHooks;
    var pageAPI = undefined;
    var pageJSON = undefined;
    if (isEntryPropsWithAPI(props)) {
        pageAPI = props.pageAPI;
    }
    else {
        pageJSON = props.pageJSON;
    }
    return (React.createElement(AppProvider, { config: config, plugins: plugins, debugHooks: debugHooks },
        React.createElement(Pages.Provider, null,
            React.createElement(PageContainer, { pageKey: pageKey, pageAPI: pageAPI, pageJSON: pageJSON }))));
}

var Kitten = /** @class */ (function () {
    function Kitten(config, plugins, debugHooks) {
        this.config = config;
        this.plugins = plugins;
        this.debugHooks = debugHooks;
    }
    Kitten.prototype.render = function (renderer, dom) {
        renderer.render(React.createElement(Index, { config: this.config, plugins: this.plugins, debugHooks: this.debugHooks }), dom, function () {
        });
    };
    return Kitten;
}());

exports.Entry = Entry;
exports.default = Kitten;
exports.isEntryPropsWithAPI = isEntryPropsWithAPI;
exports.isMenuGroup = isMenuGroup;
//# sourceMappingURL=index.js.map
